<template>
  <div class="app-container pageTopForm">
    <el-form :model="queryParams" ref="queryRef" size="small" v-show="showSearch" label-width="auto">
      <el-col :span="8">
        <el-form-item label="搜索" prop="queryName">
          <el-input
            v-model="queryParams.queryName"
            placeholder="请输入策略名称/交换机名称"
            clearable
            @keyup.enter.native="handleQuery"
          />
        </el-form-item>
      </el-col>
      <el-col :span="6">
        <el-form-item label="策略状态" prop="status">
          <el-select
            v-model="queryParams.status"
            placeholder="请选择策略状态"
            clearable>
            <el-option
              v-for="dict in dict.type.policy_status"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"/>
          </el-select>
        </el-form-item>
      </el-col>
      <el-col :span="6">
        <el-form-item class="lastBtnSty">
          <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
          <el-button icon="Refresh" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-col>
    </el-form>
    <TableList :columns="columns" :config="config" :modelIdent="this.$options.name" :queryParams="queryParams" :tableList="tableList" @fnClick="callback" @fnRenderList="getList" @value-change="handleValueChange">
      <template #tempType="{ row, column }">
        <dict-tag :options="dict.type.switch_type" :value="row.switchType"/>
      </template>
      <template #tempStatus="{ row, column }">
        <dict-tag :options="dict.type.policy_status" :value="row.status"/>
      </template>
    </TableList>
  </div>
</template>

<script setup>
  import TableList from "@/components/table/index.vue"
  import {listMonitorPolicy, delMonitorPolicy, getMonitorPolicyList} from "@/api/disRevenue/resource"
  export default {
    name: 'switchMonitorStrat',
    components: {TableList},
    dicts: ['switch_type','eps_bandwidth_type', 'policy_status'],
    data() {
      return {
        loading: true,
        showSearch: true,
        tableList: [],
        queryParams: {
          total: 0,
          pageNum: 1,
          pageSize: 10
        },
        // 列显隐信息
        columns: {
          id: { label: `ID`,width: '50'},
          policyName: { label: `策略名称`, minWidth: '250', visible: true },
          description: { label: `描述`,minWidth: '200',visible: true},
          deployDevice: { label: `部署设备`,minWidth: '200',visible: true},
          switchType: { label: `交换机类型`,minWidth: '150', slotName: 'tempType', visible: true },
          priority: { label: `优先级`,minWidth: '150', visible: true },
          connected: { label: `策略内容`,minWidth: '200'},
          status: { label: `策略状态`, minWidth: '100', slotName: 'tempStatus', visible: true },
          deployTime: { label: `下发策略时间`,minWidth: '160'},
          updateTime:{ label: `创建人`,minWidth: '160'},
          createTime: { label: `创建时间`,minWidth: '160'},
        },
        config: {
          tableButton: {
            top: [
              {content: '新增', fnCode: 'add', type: 'primary', icon: 'el-icon-plus', hasPermi: 'resource:switchMonitorStrat:add'},
              {content: '导出', fnCode: 'export', type: 'warning', icon: 'el-icon-download', hasPermi: 'resource:switchMonitorStrat:export'},
            ],
            line: [
              {content: '修改', fnCode: 'edit', type: 'text', showName: 'priority', showVal: '1', icon: 'el-icon-edit', hasPermi: 'resource:switchMonitorStrat:edit'},
              {content: '详情', fnCode: 'details', type: 'text', icon: 'el-icon-view', hasPermi: 'resource:switchMonitorStrat:details'},
              {content: '删除', fnCode: 'delete', type: 'text', showName: 'priority', showVal: '1', icon: 'el-icon-delete', hasPermi: 'resource:switchMonitorStrat:detele'},
              {}
            ]
          }
        }
      }
    },
    created() {
      this.getList();
    },
    activated() {
      this.$nextTick(() => {
        this.getList();
      });
    },
    methods: {
      /** 查询列表 */
      getList() {
        // this.$modal.loading();
        listMonitorPolicy(Object.assign({}, this.queryParams, {resourceType: 'switch'})).then(response => {
          this.tableList = response.rows;
          this.queryParams.total = response.total;
          // this.$modal.closeLoading();
        }).catch(err => {
          // this.$modal.closeLoading();
        })
      },
      // 处理子组件传递的新值
      handleValueChange(newValue) {
        // 父组件更新自身数据，实现同步
        this.showSearch = newValue;
        // console.log('父组件拿到新值:', newValue);
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },

      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryRef");
        this.handleQuery();
      },

      callback(result, rowData, selectChange, selectList) {
        if (result && result.fnCode) {
          switch (result.fnCode) {
            case 'add':
              this.$router.push({
                path:'/resource/switchMonitorStrat/details/index'});
              break;
            case 'edit':
              this.$router.push({
                path:'/resource/switchMonitorStrat/details/index',
                query:{
                  id: rowData.id
                }
              });
              break;
            case 'details':
              this.$router.push({
                path:'/resource/switchMonitorStrat/details/index',
                query:{
                  id: rowData.id,
                  readonly: true
                }
              });
              break;
            case 'delete':
              this.$modal.confirm('是否确认删除数据项？').then(function() {
                return delMonitorPolicy(rowData.id)
              }).then(() => {
                this.getList();
                this.$modal.msgSuccess("删除成功")
              }).catch(() => {});
              break;
            case 'strategy':
              this.$modal.confirm('是否确认下发策略？').then(() => {
                this.$modal.loading();
                getMonitorPolicyList(rowData.id).then(res => {
                  this.getList();
                  this.$modal.msgSuccess(res.msg);
                  this.$modal.closeLoading();
                }).catch(error => {
                  this.$modal.closeLoading();
                });
              }).catch(() => {});
              break;
            case 'export':
              // let dataList = [];
              // Object.keys(this.columns).forEach(item => {
              //   if (item.visible) {
              //     dataList.push(item.prop);
              //   }
              // });
              // this.download("/system/monitorStategy/export", {properties: dataList,}, `拓扑管理_${new Date().getTime()}.xlsx`);
              let paramsList = Object.assign({}, this.queryParams,rowData);
              this.download("rocketmq/monitorPolicy/export", paramsList, `资源监控策略_${new Date().getTime()}.xlsx`, null, 'json');
              break;
            default:
          }
        }
      }
    }
  }
</script>
<style scoped>
  ::v-deep .lastBtnSty .el-form-item__content{
    margin-left: 10px!important;
  }
</style>
